library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity interpolator_taps is

generic (
    USE_CLOCK : boolean := false);
port (
    clk   : std_logic;
    addr  : in  integer;-- address of which tap to use
    tap_0 : out integer;
    tap_1 : out integer;
    tap_2 : out integer;
    tap_3 : out integer;
    tap_4 : out integer;
    tap_5 : out integer;
    tap_6 : out integer;
    tap_7 : out integer);

end interpolator_taps;

architecture rtl of interpolator_taps is

    constant NTAPS  : integer := 8;
    constant NSTEPS : integer := 128;

    type taps_t is array(0 to NSTEPS, 0 to NTAPS - 1) of integer;

    constant taps : taps_t := 
    (
        (0, 0, 0, 0, 32767, 0, 0, 0),
        (-5, 27, -90, 258, 32718, -177, 40, -6),
        (-10, 55, -181, 520, 32665, -351, 81, -12),
        (-15, 84, -273, 785, 32605, -521, 121, -19),
        (-20, 112, -365, 1053, 32540, -689, 160, -25),
        (-25, 140, -457, 1324, 32469, -853, 199, -32),
        (-30, 168, -549, 1598, 32392, -1014, 238, -38),
        (-35, 196, -641, 1875, 32310, -1171, 276, -44),
        (-40, 224, -734, 2155, 32222, -1325, 313, -50),
        (-45, 252, -827, 2438, 32129, -1476, 350, -56),
        (-50, 279, -919, 2723, 32030, -1623, 386, -62),
        (-55, 307, -1012, 3011, 31926, -1767, 422, -68),
        (-60, 335, -1105, 3301, 31816, -1907, 457, -74),
        (-65, 362, -1197, 3594, 31701, -2044, 492, -79),
        (-70, 390, -1290, 3890, 31580, -2178, 526, -85),
        (-74, 417, -1382, 4188, 31454, -2308, 559, -91),
        (-79, 444, -1474, 4488, 31323, -2435, 592, -96),
        (-84, 471, -1565, 4790, 31187, -2558, 624, -101),
        (-89, 498, -1657, 5094, 31045, -2678, 655, -107),
        (-93, 524, -1748, 5401, 30899, -2794, 686, -112),
        (-98, 551, -1838, 5709, 30747, -2907, 716, -117),
        (-103, 577, -1928, 6019, 30590, -3017, 745, -122),
        (-107, 603, -2018, 6331, 30429, -3123, 774, -127),
        (-112, 628, -2107, 6645, 30262, -3226, 802, -131),
        (-116, 654, -2195, 6961, 30090, -3325, 829, -136),
        (-120, 679, -2283, 7278, 29914, -3421, 856, -141),
        (-125, 703, -2369, 7596, 29733, -3514, 882, -145),
        (-129, 728, -2456, 7916, 29547, -3603, 907, -149),
        (-133, 752, -2541, 8238, 29357, -3689, 931, -153),
        (-137, 775, -2625, 8560, 29162, -3771, 955, -158),
        (-141, 799, -2709, 8884, 28962, -3850, 978, -162),
        (-145, 822, -2792, 9209, 28758, -3926, 1000, -165),
        (-149, 844, -2873, 9535, 28550, -3999, 1021, -169),
        (-153, 867, -2954, 9862, 28337, -4068, 1042, -173),
        (-156, 888, -3033, 10189, 28120, -4133, 1062, -176),
        (-160, 910, -3111, 10518, 27899, -4196, 1081, -180),
        (-164, 931, -3189, 10847, 27673, -4255, 1099, -183),
        (-167, 951, -3264, 11177, 27444, -4311, 1117, -186),
        (-170, 971, -3339, 11507, 27210, -4364, 1133, -189),
        (-174, 991, -3412, 11837, 26973, -4413, 1149, -192),
        (-177, 1010, -3484, 12168, 26732, -4459, 1164, -195),
        (-180, 1028, -3554, 12500, 26487, -4503, 1179, -197),
        (-183, 1046, -3623, 12831, 26238, -4542, 1192, -200),
        (-186, 1064, -3691, 13162, 25986, -4579, 1205, -202),
        (-189, 1081, -3757, 13494, 25730, -4613, 1217, -204),
        (-191, 1097, -3821, 13825, 25470, -4643, 1228, -206),
        (-194, 1113, -3883, 14156, 25207, -4671, 1239, -208),
        (-197, 1129, -3944, 14487, 24941, -4695, 1248, -210),
        (-199, 1143, -4003, 14817, 24672, -4717, 1257, -212),
        (-201, 1157, -4060, 15147, 24399, -4735, 1265, -214),
        (-203, 1171, -4116, 15477, 24123, -4751, 1272, -215),
        (-205, 1184, -4169, 15806, 23845, -4763, 1279, -216),
        (-207, 1196, -4221, 16134, 23563, -4773, 1284, -218),
        (-209, 1208, -4271, 16461, 23278, -4780, 1289, -219),
        (-211, 1219, -4318, 16787, 22991, -4784, 1293, -220),
        (-213, 1229, -4364, 17113, 22701, -4785, 1297, -220),
        (-214, 1239, -4407, 17437, 22408, -4783, 1299, -221),
        (-215, 1248, -4448, 17760, 22113, -4779, 1301, -222),
        (-217, 1257, -4488, 18082, 21815, -4772, 1302, -222),
        (-218, 1264, -4524, 18402, 21515, -4762, 1302, -222),
        (-219, 1271, -4559, 18722, 21213, -4750, 1302, -222),
        (-220, 1278, -4591, 19039, 20908, -4734, 1301, -222),
        (-220, 1283, -4621, 19355, 20601, -4717, 1299, -222),
        (-221, 1288, -4649, 19669, 20293, -4697, 1296, -222),
        (-222, 1292, -4674, 19982, 19982, -4674, 1292, -222),
        (-222, 1296, -4697, 20293, 19669, -4649, 1288, -221),
        (-222, 1299, -4717, 20601, 19355, -4621, 1283, -220),
        (-222, 1301, -4734, 20908, 19039, -4591, 1278, -220),
        (-222, 1302, -4750, 21213, 18722, -4559, 1271, -219),
        (-222, 1302, -4762, 21515, 18402, -4524, 1264, -218),
        (-222, 1302, -4772, 21815, 18082, -4488, 1257, -217),
        (-222, 1301, -4779, 22113, 17760, -4448, 1248, -215),
        (-221, 1299, -4783, 22408, 17437, -4407, 1239, -214),
        (-220, 1297, -4785, 22701, 17113, -4364, 1229, -213),
        (-220, 1293, -4784, 22991, 16787, -4318, 1219, -211),
        (-219, 1289, -4780, 23278, 16461, -4271, 1208, -209),
        (-218, 1284, -4773, 23563, 16134, -4221, 1196, -207),
        (-216, 1279, -4763, 23845, 15806, -4169, 1184, -205),
        (-215, 1272, -4751, 24123, 15477, -4116, 1171, -203),
        (-214, 1265, -4735, 24399, 15147, -4060, 1157, -201),
        (-212, 1257, -4717, 24672, 14817, -4003, 1143, -199),
        (-210, 1248, -4695, 24941, 14487, -3944, 1129, -197),
        (-208, 1239, -4671, 25207, 14156, -3883, 1113, -194),
        (-206, 1228, -4643, 25470, 13825, -3821, 1097, -191),
        (-204, 1217, -4613, 25730, 13494, -3757, 1081, -189),
        (-202, 1205, -4579, 25986, 13162, -3691, 1064, -186),
        (-200, 1192, -4542, 26238, 12831, -3623, 1046, -183),
        (-197, 1179, -4503, 26487, 12500, -3554, 1028, -180),
        (-195, 1164, -4459, 26732, 12168, -3484, 1010, -177),
        (-192, 1149, -4413, 26973, 11837, -3412, 991, -174),
        (-189, 1133, -4364, 27210, 11507, -3339, 971, -170),
        (-186, 1117, -4311, 27444, 11177, -3264, 951, -167),
        (-183, 1099, -4255, 27673, 10847, -3189, 931, -164),
        (-180, 1081, -4196, 27899, 10518, -3111, 910, -160),
        (-176, 1062, -4133, 28120, 10189, -3033, 888, -156),
        (-173, 1042, -4068, 28337, 9862, -2954, 867, -153),
        (-169, 1021, -3999, 28550, 9535, -2873, 844, -149),
        (-165, 1000, -3926, 28758, 9209, -2792, 822, -145),
        (-162, 978, -3850, 28962, 8884, -2709, 799, -141),
        (-158, 955, -3771, 29162, 8560, -2625, 775, -137),
        (-153, 931, -3689, 29357, 8238, -2541, 752, -133),
        (-149, 907, -3603, 29547, 7916, -2456, 728, -129),
        (-145, 882, -3514, 29733, 7596, -2369, 703, -125),
        (-141, 856, -3421, 29914, 7278, -2283, 679, -120),
        (-136, 829, -3325, 30090, 6961, -2195, 654, -116),
        (-131, 802, -3226, 30262, 6645, -2107, 628, -112),
        (-127, 774, -3123, 30429, 6331, -2018, 603, -107),
        (-122, 745, -3017, 30590, 6019, -1928, 577, -103),
        (-117, 716, -2907, 30747, 5709, -1838, 551, -98),
        (-112, 686, -2794, 30899, 5401, -1748, 524, -93),
        (-107, 655, -2678, 31045, 5094, -1657, 498, -89),
        (-101, 624, -2558, 31187, 4790, -1565, 471, -84),
        (-96, 592, -2435, 31323, 4488, -1474, 444, -79),
        (-91, 559, -2308, 31454, 4188, -1382, 417, -74),
        (-85, 526, -2178, 31580, 3890, -1290, 390, -70),
        (-79, 492, -2044, 31701, 3594, -1197, 362, -65),
        (-74, 457, -1907, 31816, 3301, -1105, 335, -60),
        (-68, 422, -1767, 31926, 3011, -1012, 307, -55),
        (-62, 386, -1623, 32030, 2723, -919, 279, -50),
        (-56, 350, -1476, 32129, 2438, -827, 252, -45),
        (-50, 313, -1325, 32222, 2155, -734, 224, -40),
        (-44, 276, -1171, 32310, 1875, -641, 196, -35),
        (-38, 238, -1014, 32392, 1598, -549, 168, -30),
        (-32, 199, -853, 32469, 1324, -457, 140, -25),
        (-25, 160, -689, 32540, 1053, -365, 112, -20),
        (-19, 121, -521, 32605, 785, -273, 84, -15),
        (-12, 81, -351, 32665, 520, -181, 55, -10),
        (-6, 40, -177, 32718, 258, -90, 27, -5),
        (0, 0, 0, 32767, 0, 0, 0, 0)
    );

begin

    Clocked : if USE_CLOCK = true generate
        process(clk)
        begin
            if rising_edge(clk) then
                tap_0 <= taps(addr, 0);
                tap_1 <= taps(addr, 1);
                tap_2 <= taps(addr, 2);
                tap_3 <= taps(addr, 3);
                tap_4 <= taps(addr, 4);
                tap_5 <= taps(addr, 5);
                tap_6 <= taps(addr, 6);
                tap_7 <= taps(addr, 7);
            end if;
        end process;
    end generate Clocked;

    NonClocked : if USE_CLOCK = false generate
        tap_0 <= taps(addr, 0);
        tap_1 <= taps(addr, 1);
        tap_2 <= taps(addr, 2);
        tap_3 <= taps(addr, 3);
        tap_4 <= taps(addr, 4);
        tap_5 <= taps(addr, 5);
        tap_6 <= taps(addr, 6);
        tap_7 <= taps(addr, 7);
    end generate NonClocked;

end;